
document.addEventListener("DOMContentLoaded", function(event) {
	// safari.extension.dispatchMessage("Hello World!");

	//console.log('setting up mutation observer');

	const targetNode = document.body;
	// console.log(targetNode);

	const config = { attributes: false, childList: true, subtree: true };
	// console.log(config);

	// Callback function to execute when mutations are observed
	const callback = function(mutationsList, observer) {
		for (let mutation of mutationsList) {
			if (mutation.type === 'childList') {
				// console.log('a child node has been added or removed');

				// change primaryColumn left margin from auto to 0px
				//
				// <div class="css-1dbjc4n r-14lw9ot r-1tlfku8 r-1ljd8xs r-13l2t4g r-1phboty r-1jgb5lz r-1ye8kvj r-13qz1uu r-184en5c" data-testid="primaryColumn">
				{
					//var elements = document.getElementsByClassName("css-1dbjc4n r-aqfbo4 r-1joea0r r-zso239 r-1ovo9ad");
					var elements = document.querySelectorAll('[data-testid="primaryColumn"]');
					if (elements.length > 0) {
						var element = elements[0];
						element.style.marginLeft = "0px";
					}
				}

				// hide sidebarColumn	  
				//
				// <div class="css-1dbjc4n r-aqfbo4 r-1joea0r r-zso239 r-1ovo9ad" data-testid="sidebarColumn">
				{
					//var elements = document.getElementsByClassName("css-1dbjc4n r-aqfbo4 r-1joea0r r-zso239 r-1ovo9ad");
					var elements = document.querySelectorAll('[data-testid="sidebarColumn"]');
					if (elements.length > 0) {
						var element = elements[0];
						element.style.display = "none";
					}
				}
			
				// change position of first grandchild div of header (icons) from fixed to relative
				//
				// <header>
				//   <div>
				//     <div> = position: fixed -> relative
				//
				// <div class="css-1dbjc4n r-aqfbo4 r-1pi2tsx r-1xcajam r-ipm5af">
				{
					var elements = document.getElementsByTagName('header');

					var headerElement = elements[0];
					if (headerElement) {
						var headerDivChild = headerElement.firstChild;
						if (headerDivChild) {
							var headerDivGrandchild = headerDivChild.firstChild;
							headerDivGrandchild.style.position = "relative";
						}
					}
				}
			}
		}
	};

	// create an observer instance linked to the callback function
	const observer = new MutationObserver(callback);
	//console.log(observer);

	// start observing the target node for configured mutations
	observer.observe(targetNode, config);
});
